{***************************************}
{ calcul statistique, avec des fonctions}
{***************************************}
unit UCalcStatFonction;

interface

USES
    {lien sur l'unit contenant la fiche principale}
    UFrmPrincipale;

TYPE

    {******************************}
    {**** structure de donnes ****}
    {******************************}

    {structure de tableau de donnes relles}
    TTabDataFonction = array of double;

    {*****************************************************************}
    {*** proc et fonc manipulant les donnes passes en paramtres ***}
    {*****************************************************************}

    {rcuprer et tester les donnes de la fiche}
    function recupValeurs(var tab: TTabDataFonction; frm: TFrmStat): boolean;

    {vider le tableau}
    procedure viderTableau(var tab: TTabDataFonction);

    {calculer la moyenne  partir d'un tableau}
    function  moyenne(var tab: TTabDataFonction): double;

implementation

USES
    {sinon STRTOFLOAT n'est pas reconnu}
    Sysutils;

{rcuprer et tester les donnes}
function recupValeurs(var tab: TTabDataFonction; frm: TFrmStat): boolean;
var ok: boolean;
    n,i: integer;
begin
 n:= frm.lstbValeurs.Items.Count;
 if (n>0)
  then
   begin
    TRY
     //donner la bonne taille
     SetLength(tab,n);
     //copier les donnes aprs transtypage
     for i:= 0 to n-1 do
      tab[i]:= StrToFloat(frm.lstbValeurs.Items.Strings[i]);
     //si tout s'est bien pass, c'est le seul cas o ok est  TRUE
     ok:= TRUE;
    EXCEPT
     ok:= FALSE;
    END;
   end
  else ok:= FALSE;
 //renvoyer
 result:= ok;
end;

{vider le tableau}
procedure viderTableau(var tab: TTabDataFonction);
begin
 SetLength(tab,0);
end;

{calculer la moyenne  partir d'un tableau}
function  moyenne(var tab: TTabDataFonction): double;
var n,i: integer;
    somme: double;
begin
 n:= Length(tab);
 if (n>0)
  then
   begin
    //somme
    somme:= 0;
    for i:= 0 to n-1 do
     somme:= somme+tab[i];
    //moyenne
    result:= somme/(1.0*n);
   end
  else result:= 0.0;
end;


end.
